package server

import (
	"net"
	"google.golang.org/grpc"
	pb "git.loafle.net/overflow/overflow_api_service/grpc"
	"git.loafle.net/overflow/overflow_gateway_service/gateway"
)

func RunRpc() error {
	l, err := net.Listen("tcp", ":9090")

	if err != nil {
		return err
	}

	s := grpc.NewServer()

	pb.RegisterOverflowGatewayServer(s, &gateway.ServiceImpl{})
	s.Serve(l)

	return nil
}